#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

#define mp make_pair

using namespace std;

typedef pair<int, int> pii;

struct Animal {
    int matN;
    int r, c, k, t;
    int s; // size
};

bool CompK(const Animal &l, const Animal &r) {
    return (l.k != r.k ? l.k < r.k : l.t > r.t);
}

bool CompT(const Animal &l, const Animal &r) {
    return (l.t != r.t ? l.t > r.t : l.k < r.k);
}

struct CompKTS {
    int ck, ct, cs;
    CompKTS() {}
    CompKTS(int k, int t, int s): ck(k), ct(t), cs(s) {}
    bool operator() (const Animal &l, const Animal &r) const {
        return (ck*l.k - cs*l.s - ct*l.t) < (ck*r.k - cs*r.s - ct*r.t);
    }
};

vector<vector<int> > b, B;
vector<vector<string> > mat;
vector<Animal> an;
vector<pair<int, pii> > jumps;
vector<pair<int, pii> > JUMPS;

int n, m, p, s, S;

istream &operator >> (istream &in, Animal &an) {
    in>>an.r>>an.c>>an.k>>an.t;
    an.matN = mat.size();
    mat.push_back(vector<string>(an.r));
    an.s = 0;
    for(int i=0; i<an.r; ++i) {
        in>>mat.back()[i];
        for(int j=0; j<an.c; ++j) an.s += (mat.back()[i][j] == 1);
    }
}

pii getSum(const Animal &a, int r, int c) {
    if (r+a.r > n || c+a.c>m) return mp(0, 0);
    int sum=0, lost=0;
    for(int i=0; i<a.r; ++i) {
        for(int j=0; j<a.c; ++j) {
            if (mat[a.matN][i][j]=='0') continue;
            if (b[r+i][c+j] < a.t) return mp(0, 0);
            sum += b[r+i][c+j];
            lost += b[r+i][c+j] - b[r+i][c+j]/a.k;
        }
    }
    return mp(sum, -lost);
}

int land(const Animal &a, int r, int c) {
    if (r == -1 || c == -1) return 0;
    int sum=0;
    jumps.push_back(mp(a.matN, mp(r, c)));
    for(int i=0; i<a.r; ++i) {
        for(int j=0; j<a.c; ++j) {
            if (mat[a.matN][i][j]=='0') continue;
            sum += b[r+i][c+j];
            b[r+i][c+j] /= a.k;
        }
    }
    return sum;
}

pair<pii, pii> bestPosition(const Animal &a) {
    pii best(0, 0);
    int curScore;
    pii bestPos(-1, -1);
    if (s < a.t*a.s) return mp(best, bestPos);
    pii cur;
    for(int i=0; i+a.r<=n; ++i) {
        for(int j=0; j+a.c<=n; ++j) {
            cur = getSum(a, i, j);
            if (cur > best) {
                best = cur;
                bestPos = mp(i, j);
            }
        }
    }
    return mp(best, bestPos);
}

int tryOrder() {
    b = B;
    s = S;
    jumps.clear();
    pair<pii, pii> cur;
    int res=0;
    for(int i=0; i<an.size(); ++i) {
        cur = bestPosition(an[i]);
        res += land(an[i], cur.second.first, cur.second.second);
        s += cur.first.second;
    }
    return res;
}

//int tryFull() {
//    vector<bool> u(p, false);
//    int res=0;
//    while(1) {
//        int bestAn=-1;
//        pair<pii, pii> best, cur;
//        best = mp(mp(0, 0), mp(-1, -1));
//        for(int i=0; i<p; ++i) {
//            if (u[i]) continue;
//            cur = bestPosition(an[i]);
//            if (cur.first > best.first) {
//                best = cur;
//                bestAn = i;
//            }
//        }
//        if (bestAn == -1) break;
//        res += land(an[bestAn], best.second.first, best.second.second);
//        u[bestAn] = true;
//    }
//    return res;
//}

void printOutput() {
    cout<<JUMPS.size()<<endl;
    for(int i=0; i<JUMPS.size(); ++i) {
        cout<<JUMPS[i].first+1<<" "<<JUMPS[i].second.first+1<<" "<<JUMPS[i].second.second+1<<endl;
    }
}

void getArray(vector<int> &res) {
    res.resize(p);
    for(int i=0; i<p; ++i) res[i] = an[i].matN;
}

int main() {
    freopen("parash.in", "r", stdin);
    freopen("parash.out", "w", stdout);
    int i, j, k;
    cin>>n>>m>>p;
    B.resize(n, vector<int>(m, 0));
    S = 0;
    for(i=0; i<n; ++i) {
        for(j=0; j<m; ++j) {
            cin>>B[i][j];
            S += B[i][j];
        }
    }
    mat.clear();
    an.resize(p);
    for(k=0; k<p; ++k) {
        cin>>an[k];
    }
    int best, cur;
    best = 0;
    JUMPS.clear();

    vector<int> orderV;
    set<vector<int> > sortSet;
    for(i=0; i<5; ++i) {
        for(j=0; j<5; ++j) {
            for(k=0; k<5; ++k) {
                if (__gcd(__gcd(i, j), k) != 1) continue;
                CompKTS comp(i, j, k);
                sort(an.begin(), an.end(), comp);
                getArray(orderV);
                if (sortSet.count(orderV) > 0) continue;
                sortSet.insert(orderV);
                cur = tryOrder();
                if (cur > best) {
                    best = cur;
                    JUMPS = jumps;
                }
            }
        }
    }

    for(i=0; i<247; ++i) {
        random_shuffle(an.begin(), an.end());
        getArray(orderV);
//        if (sortSet.count(orderV)) continue;
//        sortSet.insert(orderV);
        cur = tryOrder();
        if (cur > best) {
            best = cur;
            JUMPS = jumps;
        }
    }
//    if (JUMPS.size()*21 >= p*20) {
//        cur = tryFull();
//        if (cur > best) {
//            best = cur;
//            JUMPS = jumps;
//        }
//    }
    printOutput();
//    cout<<best<<endl;
    return 0;
}
